Bug 489632 - Failed Authentication Results in Segfault
Failed Authentication Results in Segfault
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: jabberd (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: Adrian Reber
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-10 21:13 EDT by Devan Goodwin
Modified: 2009-12-18 03:59 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 03:59:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Devan Goodwin 2009-03-10 21:13:48 EDT
Description of problem:

When the jabberd service starts and authentication fails, s2s appears to segfault.

Version-Release number of selected component (if applicable):

jabberd-2.2.4-1.fc10.x86_64

How reproducible:

Seems to be 100%


Steps to Reproduce:
1. Install stock jabberd, service jabberd start. (everything is fine)
2. Modify the <secret> in /etc/jabberd/router-users.xml to anything you like. (it appears as a hash originally)
3. service jabberd restart
  
Actual results:

Service appears to start but quickly dies generating this in /var/log/messages:

Mar 10 22:05:31 kramer jabberd/sm[17036]: attempting connection to router at 127.0.0.1, port=5347
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51704] connect
Mar 10 22:05:31 kramer jabberd/sm[17036]: error from router: Authentication failed ((null))
Mar 10 22:05:31 kramer jabberd/sm[17036]: connection to router closed
Mar 10 22:05:31 kramer jabberd/sm[17036]: shutting down
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51704] disconnect
Mar 10 22:05:31 kramer jabberd/c2s[17069]: attempting connection to router at 127.0.0.1, port=5347
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51705] connect
Mar 10 22:05:31 kramer jabberd/c2s[17069]: error from router: Authentication failed ((null))
Mar 10 22:05:31 kramer jabberd/c2s[17069]: connection to router closed
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51705] disconnect
Mar 10 22:05:31 kramer jabberd/c2s[17069]: shutting down
Mar 10 22:05:31 kramer jabberd/s2s[17100]: attempting connection to router at 127.0.0.1, port=5347
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51706] connect
Mar 10 22:05:31 kramer jabberd/s2s[17100]: error from router: Authentication failed ((null))
Mar 10 22:05:31 kramer jabberd/s2s[17100]: connection to router closed
Mar 10 22:05:31 kramer jabberd/router[17005]: [127.0.0.1, port=51706] disconnect
Mar 10 22:05:31 kramer jabberd/s2s[17100]: shutting down
Mar 10 22:05:31 kramer kernel: s2s[17100]: segfault at 243c9c0 ip 000000000243c9c0 sp 00007fff2ee493e8 error 15

Expected results:

No segfault if authentication fails.

Additional info:

Originally discovered this in a Spacewalk bug which generated a more useful stack trace than this does, see bug #487618.
Comment 1 Bernie Innocenti 2009-03-11 03:13:15 EDT
Can you please retest with 2.2.7.1 from rawhide?

I could provide binaries build for F10 if needed.
Comment 2 Devan Goodwin 2009-03-12 11:10:41 EDT
I think I can test just have to find some time to spin up an F11 guest. Will try to do this sometime soon.

Binaries for F10 if not  much trouble would save me some time.
Comment 3 Devan Goodwin 2009-03-13 14:32:50 EDT
Confirmed with jabberd-2.2.7.1-1.fc10.i386.rpm.

Edit the password in /etc/jabberd/router-users.xml, change it to anything.

[root@fedorasw ~]# service jabberd restart && tail -f /var/log/messages
Terminating jabberd processes ...
Stopping router:                                           [  OK  ]
Stopping sm:                                               [FAILED]
Stopping c2s:                                              [FAILED]
Stopping s2s:                                              [FAILED]
Initializing jabberd processes ...
Starting router:                                           [  OK  ]
Starting sm:                                               [  OK  ]
Starting c2s:                                              [  OK  ]
Starting s2s:                                              [  OK  ]
Mar 13 18:29:57 fedorasw jabberd/c2s[13107]: connection to router closed
Mar 13 18:29:57 fedorasw jabberd/c2s[13107]: attempting reconnect (3 left)
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: starting up (interval=3, queue=0, keepalive=0, idle=86400)
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: couldn't open /var/run/jabberd/jabberd-s2s.pid for writing: No such file or directory
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:29:58 fedorasw jabberd/router[13033]: [127.0.0.1, port=60633] connect
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: error from router: Authentication failed ((null))
Mar 13 18:29:58 fedorasw jabberd/router[13033]: [127.0.0.1, port=60633] disconnect
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: connection to router closed
Mar 13 18:29:58 fedorasw jabberd/s2s[13144]: attempting reconnect (3 left)
Mar 13 18:29:59 fedorasw jabberd/router[13033]: [127.0.0.1, port=60635] connect
Mar 13 18:29:59 fedorasw jabberd/sm[13070]: error from router: Authentication failed ((null))
Mar 13 18:29:59 fedorasw jabberd/sm[13070]: connection to router closed
Mar 13 18:29:59 fedorasw jabberd/router[13033]: [127.0.0.1, port=60635] disconnect
Mar 13 18:29:59 fedorasw jabberd/sm[13070]: attempting reconnect (2 left)
Mar 13 18:29:59 fedorasw jabberd/c2s[13107]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:29:59 fedorasw jabberd/router[13033]: [127.0.0.1, port=60636] connect
Mar 13 18:29:59 fedorasw jabberd/c2s[13107]: error from router: Authentication failed ((null))
Mar 13 18:29:59 fedorasw jabberd/c2s[13107]: connection to router closed
Mar 13 18:29:59 fedorasw jabberd/router[13033]: [127.0.0.1, port=60636] disconnect
Mar 13 18:29:59 fedorasw jabberd/c2s[13107]: attempting reconnect (2 left)
Mar 13 18:30:00 fedorasw jabberd/s2s[13144]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:00 fedorasw jabberd/router[13033]: [127.0.0.1, port=60644] connect
Mar 13 18:30:00 fedorasw jabberd/s2s[13144]: error from router: Authentication failed ((null))
Mar 13 18:30:00 fedorasw jabberd/s2s[13144]: connection to router closed
Mar 13 18:30:00 fedorasw jabberd/s2s[13144]: attempting reconnect (2 left)
Mar 13 18:30:00 fedorasw jabberd/router[13033]: [127.0.0.1, port=60644] disconnect
Mar 13 18:30:01 fedorasw jabberd/sm[13070]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:01 fedorasw jabberd/router[13033]: [127.0.0.1, port=60658] connect
Mar 13 18:30:01 fedorasw jabberd/sm[13070]: error from router: Authentication failed ((null))
Mar 13 18:30:01 fedorasw jabberd/router[13033]: [127.0.0.1, port=60658] disconnect
Mar 13 18:30:01 fedorasw jabberd/sm[13070]: connection to router closed
Mar 13 18:30:01 fedorasw jabberd/sm[13070]: attempting reconnect (1 left)
Mar 13 18:30:01 fedorasw jabberd/c2s[13107]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:01 fedorasw jabberd/router[13033]: [127.0.0.1, port=60665] connect
Mar 13 18:30:01 fedorasw jabberd/c2s[13107]: error from router: Authentication failed ((null))
Mar 13 18:30:01 fedorasw jabberd/c2s[13107]: connection to router closed
Mar 13 18:30:01 fedorasw jabberd/router[13033]: [127.0.0.1, port=60665] disconnect
Mar 13 18:30:01 fedorasw jabberd/c2s[13107]: attempting reconnect (1 left)
Mar 13 18:30:02 fedorasw jabberd/s2s[13144]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:02 fedorasw jabberd/router[13033]: [127.0.0.1, port=60669] connect
Mar 13 18:30:02 fedorasw jabberd/s2s[13144]: error from router: Authentication failed ((null))
Mar 13 18:30:02 fedorasw jabberd/s2s[13144]: connection to router closed
Mar 13 18:30:02 fedorasw jabberd/router[13033]: [127.0.0.1, port=60669] disconnect
Mar 13 18:30:02 fedorasw jabberd/s2s[13144]: attempting reconnect (1 left)
*** glibc detected *** /usr/bin/s2s: corrupted double-linked list: 0x08fe5d50 ***
======= Backtrace: =========
/lib/libc.so.6[0x433e1f]
/lib/libc.so.6[0x434f77]
/lib/libc.so.6(cfree+0x96)[0x435356]
/usr/bin/s2s[0x8065088]
/usr/bin/s2s[0x806008b]
/usr/bin/s2s[0x804ec94]
/lib/libc.so.6(__libc_start_main+0xe5)[0x3da6e5]
/usr/bin/s2s[0x804aac1]
======= Memory map: ========
001be000-001d6000 r-xp 00000000 fc:03 588785     /lib/libaudit.so.0.0.0
001d6000-001d7000 r--p 00018000 fc:03 588785     /lib/libaudit.so.0.0.0
001d7000-001d8000 rw-p 00019000 fc:03 588785     /lib/libaudit.so.0.0.0
0039f000-003bf000 r-xp 00000000 fc:03 588794     /lib/ld-2.9.so
003c0000-003c1000 r--p 00020000 fc:03 588794     /lib/ld-2.9.so
003c1000-003c2000 rw-p 00021000 fc:03 588794     /lib/ld-2.9.so
003c4000-00532000 r-xp 00000000 fc:03 588826     /lib/libc-2.9.so
00532000-00534000 r--p 0016e000 fc:03 588826     /lib/libc-2.9.so
00534000-00535000 rw-p 00170000 fc:03 588826     /lib/libc-2.9.so
00535000-00538000 rw-p 00535000 00:00 0
0053a000-0053d000 r-xp 00000000 fc:03 588992     /lib/libdl-2.9.so
0053d000-0053e000 r--p 00002000 fc:03 588992     /lib/libdl-2.9.so
0053e000-0053f000 rw-p 00003000 fc:03 588992     /lib/libdl-2.9.so
00541000-00557000 r-xp 00000000 fc:03 589095     /lib/libpthread-2.9.so
00557000-00558000 r--p 00015000 fc:03 589095     /lib/libpthread-2.9.so
00558000-00559000 rw-p 00016000 fc:03 589095     /lib/libpthread-2.9.so
00559000-0055b000 rw-p 00559000 00:00 0
0055d000-00571000 r-xp 00000000 fc:03 231773     /usr/lib/libgsasl.so.7.6.0
00571000-00572000 rw-p 00014000 fc:03 231773     /usr/lib/libgsasl.so.7.6.0
00574000-0057b000 r-xp 00000000 fc:03 231173     /usr/lib/libntlm.so.0.0.15
0057b000-0057c000 rw-p 00006000 fc:03 231173     /usr/lib/libntlm.so.0.0.15
00588000-0059b000 r-xp 00000000 fc:03 589098     /lib/libz.so.1.2.3
0059b000-0059c000 rw-p 00012000 fc:03 589098     /lib/libz.so.1.2.3
0059e000-005b8000 r-xp 00000000 fc:03 589094     /lib/libselinux.so.1
005b8000-005b9000 r--p 00019000 fc:03 589094     /lib/libselinux.so.1
005b9000-005ba000 rw-p 0001a000 fc:03 589094     /lib/libselinux.so.1
005bc000-005c7000 r-xp 00000000 fc:03 231165     /usr/lib/libudns.so.0
005c7000-005c8000 rw-p 0000b000 fc:03 231165     /usr/lib/libudns.so.0
00603000-00634000 r-xp 00000000 fc:03 591092     /lib/libidn.so.11.5.28
00634000-00635000 rw-p 00030000 fc:03 591092     /lib/libidn.so.11.5.28
006bd000-006c8000 r-xp 00000000 fc:03 591095     /lib/libpam.so.0.81.12
006c8000-006c9000 rw-p 0000a000 fc:03 591095     /lib/libpam.so.0.81.12
00756000-00763000 r-xp 00000000 fc:03 591020     /lib/libgcc_s-4.3.2-20081105.so.1
00763000-00764000 rw-p 0000c000 fc:03 591020     /lib/libgcc_s-4.3.2-20081105.so.1
00766000-00779000 r-xp 00000000 fc:03 589093     /lib/libresolv-2.9.so
00779000-0077a000 r--p 00012000 fc:03 589093     /lib/libresolv-2.9.so
0077a000-0077b000 rw-p 00013000 fc:03 589093     /lib/libresolv-2.9.so
0077b000-0077d000 rw-p 0077b000 00:00 0
0077f000-0079f000 r-xp 00000000 fc:03 231630     /usr/lib/libgc.so.1.0.3
0079f000-007a1000 rw-p 0001f000 fc:03 231630     /usr/lib/libgc.so.1.0.3
007a1000-0080d000 rw-p 007a1000 00:00 0
0087a000-0087c000 r-xp 00000000 fc:03 589096     /lib/libcom_err.so.2.1
0087c000-0087d000 rw-p 00001000 fc:03 589096     /lib/libcom_err.so.2.1
00885000-0088e000 r-xp 00000000 fc:03 229457     /usr/lib/libkrb5support.so.0.1
0088e000-0088f000 rw-p 00008000 fc:03 229457     /usr/lib/libkrb5support.so.0.1
00891000-0092d000 r-xp 00000000 fc:03 229607     /usr/lib/libkrb5.so.3.3
0092d000-00930000 rw-p 0009b000 fc:03 229607     /usr/lib/libkrb5.so.3.3
00932000-00979000 r-xp 00000000 fc:03 589121     /lib/libssl.so.0.9.8g
00979000-0097d000 rw-p 00046000 fc:03 589121     /lib/libssl.so.0.9.8g
009ae000-009db000 r-xp 00000000 fc:03 229609     /usr/lib/libgssapi_krb5.so.2.2
009db000-009dd000 rw-p 0002d000 fc:03 229609     /usr/lib/libgssapi_krb5.so.2.2
009df000-009e1000 r-xp 00000000 fc:03 589088     /lib/libkeyutils-1.2.so
009e1000-009e2000 rw-p 00001000 fc:03 589088     /lib/libkeyutils-1.2.so
009e4000-00a08000 r-xp 00000000 fc:03 229550     /usr/lib/libk5crypto.so.3.1
00a08000-00a09000 rw-p 00024000 fc:03 229550     /usr/lib/libk5crypto.so.3.1
00a0b000-00a30000 r-xp 00000000 fc:03 591102     /lib/libexpat.so.1.5.2
00a30000-00a32000 rw-p 00024000 fc:03 591102     /lib/libexpat.so.1.5.2
00b7b000-00cb2000 r-xp 00000000 fc:03 589116     /lib/libcrypto.so.0.9.8g
00cb2000-00cc6000 rw-p 00136000 fc:03 589116     /lib/libcrypto.so.0.9.8g
00cc6000-00cc9000 rw-p 00cc6000 00:00 0
00e3a000-00e3b000 r-xp 00e3a000 00:00 0          [vdso]
08048000-0806c000 r-xp 00000000 fc:03 231643     /usr/bin/s2s
0806c000-0806d000 rw-p 00024000 fc:03 231643     /usr/bin/s2s
08fc3000-09002000 rw-p 08fc3000 00:00 0          [heap]
b7f00000-b7f21000 rw-p b7f00000 00:00 0
b7f21000-b8000000 ---p b7f21000 00:00 0
b807d000-b8083000 rw-p b807d000 00:00 0
b808c000-b808d000 rw-p b808c000 00:00 0
bfc77000-bfc8c000 rw-p bffeb000 00:00 0          [stack]
Mar 13 18:30:03 fedorasw jabberd/sm[13070]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:03 fedorasw jabberd/router[13033]: [127.0.0.1, port=60674] connect
Mar 13 18:30:03 fedorasw jabberd/sm[13070]: error from router: Authentication failed ((null))
Mar 13 18:30:03 fedorasw jabberd/router[13033]: [127.0.0.1, port=60674] disconnect
Mar 13 18:30:03 fedorasw jabberd/sm[13070]: connection to router closed
Mar 13 18:30:03 fedorasw jabberd/sm[13070]: shutting down
Mar 13 18:30:03 fedorasw jabberd/c2s[13107]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:03 fedorasw jabberd/router[13033]: [127.0.0.1, port=60675] connect
Mar 13 18:30:03 fedorasw jabberd/c2s[13107]: error from router: Authentication failed ((null))
Mar 13 18:30:03 fedorasw jabberd/router[13033]: [127.0.0.1, port=60675] disconnect
Mar 13 18:30:03 fedorasw jabberd/c2s[13107]: connection to router closed
Mar 13 18:30:03 fedorasw jabberd/c2s[13107]: shutting down
Mar 13 18:30:04 fedorasw jabberd/s2s[13144]: attempting connection to router at 127.0.0.1, port=5347
Mar 13 18:30:04 fedorasw jabberd/router[13033]: [127.0.0.1, port=60676] connect
Mar 13 18:30:04 fedorasw jabberd/s2s[13144]: error from router: Authentication failed ((null))
Mar 13 18:30:04 fedorasw jabberd/s2s[13144]: connection to router closed
Mar 13 18:30:04 fedorasw jabberd/router[13033]: [127.0.0.1, port=60676] disconnect
Mar 13 18:30:04 fedorasw jabberd/s2s[13144]: shutting down
Comment 4 Bernie Innocenti 2009-03-14 00:54:24 EDT
The backtrace is not very helpful without the debug info.  Please, install jabberd-debuginfo and run "gdb -p <pid>" on the s2s process.  Also note:

  http://fedoraproject.org/wiki/StackTraces

Anyway, it smells like an upstream bug, so I'd recommend filing it in Jabberd's trac too:

  http://jabberd2.xiaoka.com/
Comment 5 Bug Zapper 2009-11-18 06:19:34 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2009-12-18 03:59:41 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.